{/////////////////////////////////////////////////////////////////////////
//
//  Dos Navigator Open Source 1.51.08
//  Based on Dos Navigator (C) 1991-99 RIT Research Labs
//
//  This programs is free for commercial and non-commercial use as long as
//  the following conditions are aheared to.
//
//  Copyright remains RIT Research Labs, and as such any Copyright notices
//  in the code are not to be removed. If this package is used in a
//  product, RIT Research Labs should be given attribution as the RIT Research
//  Labs of the parts of the library used. This can be in the form of a textual
//  message at program startup or in documentation (online or textual)
//  provided with the package.
//
//  Redistribution and use in source and binary forms, with or without
//  modification, are permitted provided that the following conditions are
//  met:
//
//  1. Redistributions of source code must retain the copyright
//     notice, this list of conditions and the following disclaimer.
//  2. Redistributions in binary form must reproduce the above copyright
//     notice, this list of conditions and the following disclaimer in the
//     documentation and/or other materials provided with the distribution.
//  3. All advertising materials mentioning features or use of this software
//     must display the following acknowledgement:
//     "Based on Dos Navigator by RIT Research Labs."
//
//  THIS SOFTWARE IS PROVIDED BY RIT RESEARCH LABS "AS IS" AND ANY EXPRESS
//  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
//  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
//  DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE FOR
//  ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
//  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
//  GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
//  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
//  IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
//  OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
//  ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
//  The licence and distribution terms for any publically available
//  version or derivative of this code cannot be changed. i.e. this code
//  cannot simply be copied and put under another distribution licence
//  (including the GNU Public Licence).
//
//////////////////////////////////////////////////////////////////////////}
{$I STDEFINE.INC}
unit DNExec;

interface

uses
  files,
  UserMenu, Startup, Objects, FilesCol, Commands, TitleSet
  {$IFDEF DPMI}, DPMI {$ENDIF}
  ;

{$IFNDEF VIRTUALPASCAL}
procedure SaveDsk;
{$ENDIF}
procedure ExecString(S: PString; WS: String);
function  SearchExt(FileRec: PFileRec; var HS: String): Boolean; {DataCompBoy}
function  ExecExtFile(const ExtFName: string; UserParams: PUserParams; SIdx: TStrIdx): Boolean; {DataCompBoy}
procedure ExecFile(const FileName: string); {DataCompBoy}

procedure AnsiExec(const Path: String; const ComLine: AnsiString); {JO}

const
  fExec: boolean = false; {믮  ணࠬ}

implementation

uses
{$IFDEF OS2}
  Os2Base,
{$ENDIF}
{$IFDEF WIN32}
  Windows,
{$ENDIF}
  DnUtil, Advance, DnApp, Advance1, LFN,
  Dos, Advance3, FlPanelX, CmdLine, Views, Advance2, Drivers, Advance4,
{$IFDEF VIRTUALPASCAL}
  Videoman, Memory, VPSysLow, VpSysLo2,
{$ENDIF}
{$IFDEF UserSaver}
  UserSavr,
{$ENDIF}
  Messages, Strings;

{$IFDEF OS_DOS}
procedure SaveDsk;
begin
 ClrIO;
 if ((OpSys <> opDos) or (StartupData.Unload and osuAutosave = 0))
    and not (TottalExit) then
  PDNApplication(Application)^.SaveDesktop(SwpDir+'DN'+ItoS(DNNumber)+'.SWP');
end;
{$ENDIF}

{JO}
{$IFDEF VIRTUALPASCAL}
{ AnsiExec -  DOS.Exec ,   ⢥ }
{  ᯮ ப ⨯ Ansistring }
{  ᮮ⢥⢥   ࠭祭  255 ᨬ}
procedure AnsiExec(const Path: String; const ComLine: AnsiString);
var
  PathBuf: array [0..255] of Char;
  Ans1: AnsiString;
begin
  Ans1 := ComLine + #0;

  SysTVKbdDone; {JO: . VpSysLo2 ; ᫨ ⮣   -  맮     }
                {    ᮫ ணࠬ த 娢஢   }
                {       "ࠢ"  ஬}
                {    (ਬ, 4OS2) 譨 ணࠬ      }
                {                                               }

  {Cat: ⮡   Win9x  ମ, 蠥  ਮ. , 祬
        ⠢  襭 ਮ  ᪥ 譨 ணࠬ}
  {$IFDEF WIN95_HIGHPRIORITY}
  if SysPlatformId = 1 then {Win9x}
    begin
      SetPriorityClass(GetCurrentProcess, Normal_Priority_Class);
      DosError := SysExecute(StrPCopy(PathBuf, Path), PChar(Ans1), nil, ExecFlags = efAsync, nil, -1, -1, -1);
      SetPriorityClass(GetCurrentProcess, High_Priority_Class);
    end
  else {WinNT}
  {$ENDIF}
  {/Cat}
    DosError := SysExecute(StrPCopy(PathBuf, Path), PChar(Ans1), nil, ExecFlags = efAsync, nil, -1, -1, -1);

  SysTVKbdInit; {Cat:  OS/2: ६  樥 Ctrl-C  Ctrl-Break
                       WinNT: ६  ய 設 }
end;
{$ENDIF}
{/JO}

{$IFDEF Win32}
{AK155 30-12-2001
 ⪠ । ⨯ 뢠 ணࠬ, ⮡ GUI-ணࠬ
뢠   襭,   稥 -  .
᫨ ७  㪠,   ⮪ ᯮ GUI-ணࠬ
 .  ⭮  ந,   ६ 㦥
Path, ⠪   㤭 ᤥ  ਢ. ਬ, ᫨ ᪠
 prog,  ࠢ쭮 ᪠   䠩 prog.exe.  ,
 ,  - ࠭, ਬ,  ⥪饬 ⠫,  prog.com
 prog.cmd,    맮,   GUI. , Far  
⠪.   ⥪騩 ⠫ notepad.cmd    ப notepad.
 ⮬  Enter   ⮬ ᠬ notepad.cmd.
}
function GUIProgram(S: PString): boolean;
  const
    PETag = $00004550; {'PE'#0#0}
  var
    f: file;
    PathEnv: string;
    Dir: DirStr;
    Name: NameStr;
    Ext: ExtStr;
    RealName: string;
    NewExeOffs: SmallWord;
    NewHeader: record
      Signature: longint;
      dummy1: array[1..16] of byte;
      SizeOfOptionalHeader: SmallWord;
      Characteristics: SmallWord;
   {OptionalHeader}
      dummy2: array[1..68] of byte;
      Subsystem: SmallWord;
      end;
    l: longint;
  begin
  GUIProgram := false;
  FSplit(S^, Dir, Name, Ext);
  UpStr(Ext);
  if Ext <> '.EXE' then
    exit;
  RealName := S^;
  assign(f, RealName); reset(f, 1);
  if (IOResult <> 0) and (Dir = '') then
    begin
    PathEnv := GetEnv('PATH');
    RealName := FSearch(S^, PathEnv);
    if RealName = '' then
      exit;
    assign(f, RealName); reset(f, 1);
    if IOResult <> 0 then
      exit; {-, ⠪   , ࠧ   諨}
    end;
  Seek(f, $3C);
  BlockRead(f, NewExeOffs, 2, l);
  if (NewExeOffs=0) or (l <> 2) then
    begin
      close(f); {Cat}
      exit;
    end;
  Seek(f, NewExeOffs);
  BlockRead(f, NewHeader, SizeOf(NewHeader), l);
  with NewHeader do
    begin
    if (l < 70) or (Signature <> PETag) or (SizeOfOptionalHeader < 70) then
      begin
        close(f); {Cat}
        exit;
      end;
    if Subsystem = 2 {IMAGE_SUBSYSTEM_WINDOWS_GUI} then
      GUIProgram := true;
    end;
  close(f);
  end;
{$ENDIF}

{$IFDEF OS2}
{Cat 12-01-2002
 ⪠ । ⨯ 뢠 ணࠬ, ⮡ GUI-ணࠬ
뢠   襭,   稥 -  .
 OS/2 訢 DosQueryAppType, ,  뢠 ᯥਬ,
 ᯥ譮 ࠡ⠥  ⮫쪮   䠩,  ᪠  㬥樨,
  㤠 ᪮ନ  楫  ப ( , ⥬ ᠬ
뢠  । ப ࠬ  ⢫  
६ 㦥 Path). 筮,  ࠭⨨,   㤥 ᥣ
ࠡ ࠢ쭮,      㤠 ᤥ .
}
function GUIProgram(S: PString): Boolean;
var
  SS: String;
  Flags: LongInt;
begin
  SS := S^+#0;
  if DosQueryAppType(@SS[1], Flags) <> 0 then
  {  ᮡ 砨, ਢ騥  訡,  易   ஡:
    2    Error_File_Not_Found
           ᫨  㪠 ७, ⥬ । EXE, ⮬ 
           訡 ᮮ頥  COM, BAT, CMD-䠩, ᫨ EXE  ⠪ 
             . ᫨   ᮮ⢥騩 EXE,   
           㦥, ᪮ ᬮ७ 㤥 EXE - ,  饭 COM,
           BAT, CMD  ⥪饣 ⠫.
    191  Error_Invalid_Exe_Signature
            ᮮ頥   䠩,     "ᠬ
            ᥡ",     BAT  CMD ⮦ -  
            ஬. ,  COM-䠩,    
           ᮤঠ ⮩ ᠬ Exe_Signature, 訡  .
  }
    GUIProgram := False
  else
  { ᬠਢ 騥  䫠   2-0:
      000   fapptyp_NotSpec
      001   fapptyp_NotWindowCompat
      010   fapptyp_WindowCompat
      011   fapptyp_WindowApi
  }
    GUIProgram := (Flags and 3 = 3);
end;
{/Cat}
{$ENDIF}

        {-DataCompBoy-}
procedure ExecString(S: PString; WS: String);
 var I: Integer;
{$IFNDEF VIRTUALPASCAL}
     F1: lText;
     M: String;
{$ELSE}
     SM: Word;
     EV: TEvent;
     X, Y: SmallWord; {Cat}
     ScreenSize: TSysPoint; {Cat}
{$ENDIF}
{$IFNDEF VIRTUALPASCAL}
 label 1;
{$ENDIF}

begin
{$IFNDEF VIRTUALPASCAL}
 M:=S^;
 DelRight(M);
 if {$IFDEF OS_DOS}not Chk4Dos and {$ENDIF}(Pos('||', M) <> 0) then
  begin
    lAssignText(F1, SwpDir+'$DN'+ItoS(DNNumber)+'$.BAT'); ClrIO;
    lRewriteText(F1); if IOResult <> 0 then begin Close(F1.T); Exit; end;
    I := 0;
    repeat
      I := Pos('||', M);
      if I = 0 then I := Length(M)+1;
      WriteLn(F1.T, MakeCMDParams(Copy(M, 1, I-1),
                                CnvString(CurFileActive),
                                CnvString(CurFilePassive)));
      Delete(M, 1, I+1);
    until (M = '');
    Close(F1.T);
    M := SwpDir+'$DN'+ItoS(DNNumber)+'$.BAT ';
  end else M := MakeCMDParams(M, CnvString(CurFileActive), CnvString(CurFilePassive));
1:
 M := ' '+M+#13; SetLength(M, Length(M)-1);
{ ----- }
 SaveDsk;
 Exiting:=True;
 Application^.Done;
 if WS<>'' then Writeln(WS);
 if (LoaderSeg <> 0) then Move(M, mem[LoaderSeg:CommandOfs], Length(M)+2);
 if (SystemData.Options and ossFastExec <> 0) or RunFrom2E
 then asm
  mov ax, 9903h
  mov cl, 1
  int 2Fh
 end;
 if TimerMark then DDTimer := Get100s
              else DDTimer := 0;
 asm
    mov ax, 9904h
    mov dx, word ptr DDTimer
    mov cx, word ptr DDTimer+2
    int 2Fh
    mov ax, 9902h
    mov cl, 1
    int 2Fh
 end;
 Halt(1);
{$ELSE}
  SM := ScreenMode;
  DoneSysError;
  DoneEvents;
  DoneVideo;
  DoneDOSMem;
  DoneMemory;
  {$IFDEF OS_DOS}asm cld; mov eax,3; int $10; end;{$ENDIF}
  SwapVectors;
  if TimerMark then DDTimer := Get100s
               else DDTimer := 0;
  if WS<>'' then Writeln(WS);
  SetTitle(S^);
  fExec := True;
{$IFNDEF DPMI32}
  if GUIProgram(S) then
    S^ := 'start ' + S^;
{$ENDIF}
  AnsiExec(GetEnv('COMSPEC'),'/c '+S^);
  fExec := False;
{AK155, Cat: ⮡ ப      뢮}
  SysGetCurPos(X, Y);
  if InterfaceData.Options and ouiHideStatus = 0 then
    inc(Y);
  if X <> 0 then
    writeln;
  SysTvGetScrMode(@ScreenSize);
  if Y >= ScreenSize.Y then
    writeln;
{/AK155, Cat}
  if TimerMark then begin
   DDTimer := Get100s-DDTimer;
   ev.what:=evCommand;
   ev.command:=cmShowTimeInfo;
   ev.infoptr:=nil;
   Application^.PutEvent(ev);
  end;
  I := DosError; ClrIO;
  SwapVectors;
  EraseFile(SwpDir+'$DN'+ItoS(DNNumber)+'$.LST'); {DataCompBoy}
  InitDOSMem;
  InitMemory;
  InitVideo;
  if StartupData.Load and osuRestoreScrMode <> 0 then ScreenMode := SM;
  SetVideoMode(ScreenMode);
  SetBlink(CurrentBlink);
  if (StartupData.Load and osuResetPalette <> 0) then SetPalette(VGA_Palette);
  InitEvents;
  InitSysError;
  Application^.Redraw;
  GlobalMessage(evCommand, cmPanelReread, nil);
  GlobalMessage(evCommand, cmRereadInfo, nil);
{$ENDIF}

{AK155  ⮣  ப  ⠭  }
{$IFDEF Win32}
  if (CommandLine <> nil) then
    begin
    SysTVSetCurPos(-2, -2);
    SysCtrlSleep(1); //   ⪨ 
    CommandLine^.Update;
    end;
{$ENDIF}
{/AK155}
end;
        {-DataCompBoy-}

        {-DataCompBoy-}
function SearchExt(FileRec: PFileRec; var HS: String): Boolean;
var
  AllRight : Boolean;
  f        : PTextReader;
  F1       : lText;
  s,s1     : String;
  BgCh,EnCh: Char;
  EF, First: Boolean;
  I        : Integer;
  Local    : Boolean;
  FName: string;
  UserParam: TUserParams;
  D        : TMaskData;
 {$IFDEF OS2}
  WriteEcho: Boolean;
 {$ENDIF}
label RL;

begin
  fillchar(D, sizeof(d), 0);
  First := True;
  Message(Desktop, evBroadcast, cmGetUserParams, @UserParam);
  UserParam.Active:=FileRec;
  FName:=FileRec^.FlName[true];
  {lGetDir(0, ActiveDir);} {Cat:warn ஢    ⫮ ,   㤥 ஢,    }
  SearchExt:=False;
  Local := true;
  f := New(PTextReader, Init('DN.EXT'));
  if f=nil then
   begin
  RL:
     Local := false;
     f := New(PTextReader, Init(SourceDir+'DN.EXT'));
   end;
  if f=nil then exit; AllRight:=False;
  BgCh:='{';EnCh:='}'; Abort := false; EF:=false;
  if PShootState and 8 > 0 then begin BgCh:='[';EnCh:=']';end else
  if PShootState and 3 > 0 then begin BgCh:='(';EnCh:=')';end;
  While (not f^.EOF) and (not AllRight) do begin
    S := f^.GetStr;
    if S[1] <> ' ' then
     begin
      I := PosChar(BgCh, S); if (I = 0) or (S[I+1]=BgCh) then Continue;
      S1 := Copy(S, 1, I-1);
      DelLeft(S1);
      DelRight(S1);
      if S1[1]<>';' then begin
       D.Filter := S1;
       MakeTMaskData(D);
       if InExtFilter(FName, D) then begin
        lAssignText(F1, SwpDir+'$DN'+ItoS(DNNumber)+'$'+CmdExt); ClrIO;
        lRewriteText(F1); if IOResult <> 0 then
          begin
            Dispose(F,Done);
            FreeTMaskData(D); {Cat}
            Exit;
          end;
       {$IFNDEF OS2}
        Writeln(F1.T, '@echo off');
       {$ELSE}
        WriteEcho := true;
       {$ENDIF}
        System.Delete(S, 1, PosChar(BgCh, S));
        repeat
         Replace(']]', #0, S);
         Replace('))', #1, S);
         Replace('}}', #2, S);
         DelLeft(S); DelRight(S);
         if S[Length(S)] = EnCh then
          begin SetLength(S, Length(S)-1); EF := true; if S <> '' then
           begin
             Replace(#0, ']', S);
             Replace(#1, ')', S);
             Replace(#2, '}', S);
             S := MakeString(S, @UserParam, false, nil);
             HS := S;
             {$IFDEF OS2}
             {JO:   ᫨ ப  REXX'  Perl',   㦭  @Echo off}
              if WriteEcho and (Copy(S, 1, 2) <> '/*') and (Copy(S, 1, 2) <> '#!') then Writeln(F1.T, '@Echo off');
              WriteEcho := false;
             {$ENDIF}
             WriteLn(F1.T, S); Break
           end;
          end;
         if S <> '' then
          begin
           Replace(#0, ']', S);  Replace(#1, ')', S);  Replace(#2, '}', S);
           if (BgCh <> '[') then S := MakeString(S, @UserParam, false, nil);
           if First and (BgCh <> '[') then HS := S;
             {$IFDEF OS2}
             {JO:   ᫨ ப  REXX'  Perl',   㦭  @Echo off}
              if WriteEcho and (Copy(S, 1, 2) <> '/*') and (Copy(S, 1, 2) <> '#!') then Writeln(F1.T, '@Echo off');
              WriteEcho := false;
             {$ENDIF}
           WriteLn(F1.T, S);
           First := False;
          end;
         if (F^.EOF) then Break;
         if not EF then S := F^.GetStr;
        until (IOResult <> 0) or Abort or EF;
        Close(F1.T);
        AllRight := true;
       end;
      end;
     end;
  end;
  Dispose(F,Done);
  {D.Filter:=''; MakeTMaskData(D);}
  FreeTMaskData(D); {Cat}
  if not EF and not Abort and Local then Goto RL;
  if EF and (BgCh = '[') then
   begin
    EraseFile( SwpDir+'$DN'+ItoS(DNNumber)+'$.MNU' );
    lRenameText(F1, SwpDir+'$DN'+ItoS(DNNumber)+'$.MNU');
    EF := ExecUserMenu(false);
    if not EF then lEraseText(F1);
   end;
  SearchExt:=not Abort and EF;
  FreeTMaskData(D); {Cat}
end;
        {-DataCompBoy-}

        {-DataCompBoy-}
function ExecExtFile(const ExtFName: string; UserParams: PUserParams; SIdx: TStrIdx): Boolean;
 var F: PTextReader;
     S,S1: String;
     FName, LFN: String;
     Event: TEvent;
     I,J: Integer;
{$IFNDEF VIRTUALPASCAL}
     PP: PView;
{$ENDIF}
     Success, CD: Boolean;
     Local: Boolean;
     D: TMaskData;
 label 1,1111, RepeatLocal;

begin
 FillChar(D, sizeof(D), 0);
 ExecExtFile := false;
 FileMode := $40;
 Local := true;
 LFN := UserParams^.Active^.FlName[true];
 if CharCount('.', LFN)=0 then LFN:=LFN+'.';
 FName := UserParams^.Active^.FlName[true xor InvLFN];

 F := New(PTextReader, Init(ExtFName));

 if F = nil then
  begin
RepeatLocal:
    Local := false;
    F := New(PTextReader, Init(SourceDir+ExtFName));
  end;
 if F = nil then Exit;
 While not F^.EOF do
   begin
      S := F^.GetStr;
      DelLeft(S);
      S1:=fDelLeft(Copy(S, 1, pred(PosChar(':', S))));
      if (S1='') or (S1[1]=';') then continue;
      D.Filter := S1; MakeTMaskData(D);
      if InExtFilter(FName, D) or InExtFilter(LFN, D) then goto 1111;
   end;
   ExecExtFile := false;
   Dispose(F, Done);
   {D.Filter := ''; MakeTMaskData(D);}
   FreeTMaskData(D); {Cat}
   if Local then Goto RepeatLocal;
   FreeTMaskData(D); {Cat}
   Exit;
1111:
   Delete(S, 1, succ(Length(S1)));
   Dispose(F, Done);
   if not Application^.Valid(cmQuit) then
     begin
       FreeTMaskData(D); {Cat}
       Exit;
     end;
   ClrIO;
   S1:='';
   S:=MakeString(S, UserParams, false, @S1);
   if S1<>''
    then TempFile:='!'+S1+'|'+MakeNormName(UserParams^.Active^.Owner^, LFN)
    else if TempFile<>''
          then TempFile:=MakeNormName(UserParams^.Active^.Owner^, LFN);
{$IFDEF VIRTUALPASCAL}
  {if TempFile <> '' then SaveDsk;}
   TempFileSWP := TempFile;
   TempFile := '';
{$ENDIF}
   if Abort then
     begin
       FreeTMaskData(D); {Cat}
       Exit;
     end;
   if S[1] = '*' then Delete(S, 1, 1); {DelFC(S);}
{$IFNDEF VIRTUALPASCAL}
   PP := _WriteMsg(' '+GetString(SIdx));
   if not CheckExit then
     begin
       ExecExtFile:=false;
       FreeTMaskData(D); {Cat}
       Exit;
     end;
{$ENDIF}
   lGetDir(0, S1);
{$IFDEF OS_DOS}
   if UpStrg(MakeNormName(lfGetLongFileName(UserParams^.Active^.Owner^),'.'))<>
      UpStrg(MakeNormName(S1,'.'))
    then begin
          DirToChange:=S1;
          lChDir(lfGetLongFileName(UserParams^.Active^.Owner^));
         end;
{$ELSE}
   if UpStrg(MakeNormName(UserParams^.Active^.Owner^,'.'))<>
      UpStrg(MakeNormName(S1,'.'))
    then begin
          DirToChange:=S1;
          lChDir(UserParams^.Active^.Owner^);
         end;
{$ENDIF}
   ExecExtFile := true;
   Message(Desktop, evBroadcast, cmGetCurrentPosFiles, nil);
{$IFDEF UserSaver}
   InsertUserSaver(false); {JO}
{$ENDIF}
   ExecString(@S, '');
{$IFDEF VIRTUALPASCAL}
   if TempFileSwp <> '' then Message(Application, evCommand, cmRetrieveSwp, nil);
{$ENDIF}
end;
        {-DataCompBoy-}

        {-DataCompBoy-}
procedure ExecFile(const FileName: string);
 var S,
{$IFNDEF OS2}
     L,
{$ENDIF}
     M: String;
     fr: PFileRec;

 procedure PutHistory(B: Boolean);
 begin
  if M = '' then Exit;
  CmdLine.Str := M;
  CmdLine.StrModified := true;
  CmdDisabled := B;
  Message(CommandLine, evKeyDown, kbDown, nil);
  Message(CommandLine, evKeyDown, kbUp, nil);
 end;

 procedure RunCommand(B: Boolean);
   var ST: SessionType;
    S: string; {//AK155}
 begin
{$IFNDEF Win32}
    if (PCommandLine(CommandLine)^.LineType in [ltOS2Window,ltOS2FullScreen]) then
     begin
       if PCommandLine(CommandLine)^.LineType = ltOS2FullScreen then
         ST := stOS2FullScreen
       else ST := stOS2Windowed;
       RunOS2Command(M, false, ST);
       CmdLine.StrModified := true;
       Message(CommandLine, evKeyDown, kbDown, nil);
       Exit;
     end;
{$ENDIF}
{AK155, . dnutil.ExecCommandLine}
    S:='';CommandLine^.SetData(S);
{/AK155}
    if B then ExecString(@M, #13#10 + {$IFDEF RecodeWhenDraw}CharToOemStr{$ENDIF}(ActiveDir) + '>' + {$IFDEF RecodeWhenDraw}CharToOemStr{$ENDIF}(M))
     else ExecString(@M, '');
 end;

label ex;
begin
 fr:= CreateFileRec(FileName);
 S := fr^.FlName[true];
{$IFNDEF OS2}
 L := S;
{$ENDIF}
 FreeStr := '';
 M := '';
 if (ShiftState and (3 or kbAltShift) <> 0) or
    (not InExtFilter(S, Executables)
     {$IFNDEF OS2}and not InExtFilter(L, Executables){$ENDIF}) then
  begin
   if SearchExt(fr, M) then
   begin
   {PutHistory(true);}
    M := SwpDir+'$DN'+ItoS(DNNumber)+'$' + CmdExt + ' ' + FreeStr;
    RunCommand(false);
   {M := S; PutHistory(false);}
   {CmdDisabled := false;}
    GlobalMessage(evCommand, cmClearCommandLine, nil);
   end;
   goto ex;
  end;
{$IFNDEF Win32}
 M := S;
{$ELSE}
 M := {$IFDEF RecodeWhenDraw}CharToOemStr{$ENDIF}(L);
{$ENDIF}
 PutHistory(false);
{$IFNDEF Win32}
 M := S;
{$ELSE}
 M := L;
{$ENDIF}

 if Pos(' ', M) <> 0 then {AK155}
{$IFDEF OS2}
   M := '""' + M + '""';
{$ELSE}
   M := '"' + M + '"';
{$ENDIF}

 RunCommand(true);
ex:
 DelFileRec(fr);
end;

end.
